DROP TABLE cloudconfig;
DROP TABLE schedconfig;


CREATE TABLE cloudconfig
(
                     name     VARCHAR(20) primary key,
              description     VARCHAR(50),
                    tier1     VARCHAR(20),
                  tier1SE    VARCHAR(400),
               relocation     VARCHAR(10),
                   weight      NUMBER(11) default          0,
                   server    VARCHAR(100),
                   status     VARCHAR(20),
              transtimelo      NUMBER(11) default          0,
              transtimehi      NUMBER(11) default          0,
                 waittime      NUMBER(11) default          0,
             cloudcomment    VARCHAR(200),
                    space      NUMBER(11) default          0,
                  moduser     VARCHAR(30),
                  modtime           DATE default CURRENT_DATE,
               validation     VARCHAR(20),
                  mcshare      NUMBER(11) default          0,
                countries     VARCHAR(80)
);


CREATE TABLE schedconfig
(
                     name     VARCHAR(60) default    'default',
                 nickname     VARCHAR(60) primary key,
                    queue     VARCHAR(60),
               localqueue     VARCHAR(20),
                   system     VARCHAR(60),
                sysconfig     VARCHAR(20),
                  environ    VARCHAR(250),
               gatekeeper     VARCHAR(40),
               jobmanager     VARCHAR(80),
                       se    VARCHAR(250),
                      ddm     VARCHAR(80),
                   jdladd            CLOB default       NULL,
                globusadd    VARCHAR(100),
                      jdl     VARCHAR(60),
                   jdltxt            CLOB default       NULL,
                  version     VARCHAR(60),
                     site     VARCHAR(60),
                   region     VARCHAR(60),
                    gstat     VARCHAR(60),
                     tags    VARCHAR(200),
                      cmd    VARCHAR(200),
                  lastmod       TIMESTAMP default CURRENT_TIMESTAMP,
                  errinfo     VARCHAR(80),
                   nqueue      NUMBER(11) default          0,
             queuecomment            CLOB default       NULL,
                   appdir     VARCHAR(80),
                  datadir     VARCHAR(80),
                   tmpdir     VARCHAR(80),
                 wntmpdir     VARCHAR(80),
                   dq2url     VARCHAR(80),
              special_par     VARCHAR(80),
              python_path     VARCHAR(80),
                    nodes      NUMBER(11) default          0,
                   status     VARCHAR(10),
                 copytool     VARCHAR(80),
                copysetup    VARCHAR(200),
                 releases    VARCHAR(500),
                   sepath     VARCHAR(80),
                 envsetup    VARCHAR(200),
               copyprefix    VARCHAR(160),
                  lfcpath     VARCHAR(80),
                    seopt     VARCHAR(60),
                     sein     VARCHAR(60),
                  seinopt     VARCHAR(60),
                  lfchost     VARCHAR(80),
                    cloud     VARCHAR(60),
                   siteid     VARCHAR(60),
                    proxy     VARCHAR(80),
                    retry     VARCHAR(10),
               queuehours       NUMBER(9) default          0,
               envsetupin    VARCHAR(200),
               copytoolin    VARCHAR(180),
              copysetupin    VARCHAR(200),
               seprodpath    VARCHAR(200),
              lfcprodpath     VARCHAR(80),
             copyprefixin     VARCHAR(80),
               recoverdir     VARCHAR(80),
                   memory      NUMBER(11) default          0,
                  maxtime      NUMBER(11) default          0,
                    space      NUMBER(11) default          0,
                   tspace       TIMESTAMP default TO_DATE('0001-01-01 00:00:00','YYYY-MM-DD HH24:MI:SS'),
                cmtconfig    VARCHAR(250),
                 setokens     VARCHAR(80),
                   glexec     VARCHAR(10),
           priorityoffset     VARCHAR(60),
            allowedgroups    VARCHAR(100),
             defaulttoken    VARCHAR(100)
);
